#
# 
# Usage: python streamIdealK.py <trace> <N> <segsec> <case>
#
# where: 
#  <trace> : trace filename, generated by LossVectorGenerator
#  <N> : number of packets per segment
#  <segsec> : length of segment in seconds
#  <case> : case name identifier
#
import sys


def main():
    idealK=0
    print "trace file: ", sys.argv[1]
    with open(sys.argv[1]) as f:
        f.readline() # Total number of packets, discarded
        N=int(sys.argv[2]) 
        histo = [0] * (N+1)
        lost = 0
        total = 0 
        iN = 0
        segmentlength = int(sys.argv[3])
        totalseg = 24*60*60 / segmentlength
        segi = 0
        totalpkts = 0
        maxlost = 0
        while True:
            c = f.read(1)
            totalpkts += 1
            iN += 1
            if not c:
                print "!!!! End of file !!!!!"
                break
            if c=='1': 
                lost += 1
            if iN == N: 
                segi += 1
                histo[lost] += 1
                if lost > maxlost:
                    maxlost = lost
                total += lost;
                lost = 0
                iN = 0
                if segi == totalseg:
                    break
        print "Loss   #Segments  #errs  K"
        for i in range(0, maxlost+1):
            total_errors = sum(histo[i+1:])
            print "%4d  %7d  %7d  %3d" % (i, histo[i], total_errors, N-i)
            if idealK == 0 and total_errors <= 24:
                idealK = N-i
        print "loss pkts= %d, (percent loss= %.4f)" % (total, 100.0*total/totalpkts)
        print "Total # of segments = %d  (24h = 24*60*60/pp = %d segments, N=%d)" % (sum(histo[:]), 24*60*60/segmentlength, N)
        print sys.argv[4]," K=",idealK
            
if __name__ == "__main__" :
    try: 
        main()
    except KeyboardInterrupt:
        print "\n\n\a@ cleanup complete, have a nice day"
